"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var TinyTransition = function (_React$Component) {
  _inherits(TinyTransition, _React$Component);

  function TinyTransition() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, TinyTransition);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(TinyTransition)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "state", {
      children: _this.props.disableInitialAnimation ? _this.props.children : null
    });

    _defineProperty(_assertThisInitialized(_this), "animationTimer", void 0);

    _defineProperty(_assertThisInitialized(_this), "delayTimer", void 0);

    _defineProperty(_assertThisInitialized(_this), "isAnimating", false);

    _defineProperty(_assertThisInitialized(_this), "raf", void 0);

    _defineProperty(_assertThisInitialized(_this), "waitForNode", function (callback) {
      if (!_assertThisInitialized(_this)) return;

      var node = _reactDom["default"].findDOMNode(_assertThisInitialized(_this));

      if (node) {
        callback(node);
      } else {
        _this.raf = requestAnimationFrame(function () {
          _this.waitForNode(callback);
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "clearTimers", function () {
      cancelAnimationFrame(_this.raf);
      clearTimeout(_this.animationTimer);
      clearTimeout(_this.delayTimer);
      _this.isAnimating = false;
    });

    _defineProperty(_assertThisInitialized(_this), "animateIn", function () {
      if (!(0, _utils.canAnimate)()) {
        _this.setState({
          children: _this.props.children
        });

        return;
      }

      _this.clearTimers();

      _this.isAnimating = true;
      _this.delayTimer = setTimeout(function () {
        _this.setState({
          children: _this.props.children
        }, function () {
          var classNames = _this.props.classNames;

          _this.waitForNode(function (node) {
            (0, _utils.resetClassList)(node, classNames);
            (0, _utils.addClasses)(node, classNames.beforeEnter);
            _this.raf = requestAnimationFrame(function () {
              _this.raf = requestAnimationFrame(function () {
                (0, _utils.addClasses)(node, classNames.entering);
              });
            });
            _this.animationTimer = setTimeout(function () {
              (0, _utils.resetClassList)(node, classNames);
              _this.isAnimating = false;

              _this.setState({});
            }, _this.props.duration);
          });
        });
      }, _this.props.delay);
    });

    _defineProperty(_assertThisInitialized(_this), "animateOut", function () {
      if (!(0, _utils.canAnimate)()) {
        _this.setState({
          children: _this.props.children
        });

        return;
      }

      var node = _reactDom["default"].findDOMNode(_assertThisInitialized(_this));

      var classNames = _this.props.classNames;
      if (!node) return;

      _this.clearTimers();

      _this.isAnimating = true;
      _this.delayTimer = setTimeout(function () {
        (0, _utils.resetClassList)(node, classNames);
        (0, _utils.addClasses)(node, classNames.beforeLeave);
        _this.raf = requestAnimationFrame(function () {
          (0, _utils.addClasses)(node, classNames.leaving);
        });
        _this.animationTimer = setTimeout(function () {
          _this.isAnimating = false;

          _this.setState({
            children: _this.props.children
          });
        }, _this.props.duration);
      }, _this.props.delay);
    });

    return _this;
  }

  _createClass(TinyTransition, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      if (this.props.children && !this.props.disableInitialAnimation) {
        this.raf = requestAnimationFrame(function () {
          _this2.animateIn();
        });
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.clearTimers();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var newChildren = _react.Children.toArray(this.props.children);

      var oldChildren = _react.Children.toArray(prevProps.children);

      if (newChildren.length !== oldChildren.length) {
        if (newChildren.length) {
          this.animateIn();
        } else {
          this.animateOut();
        }
      } else if (this.props.children !== this.state.children && !this.isAnimating) {
        this.setState({
          children: this.props.children
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      return this.state.children;
    }
  }]);

  return TinyTransition;
}(_react["default"].Component);

_defineProperty(TinyTransition, "propTypes", {
  children: _propTypes["default"].node,
  classNames: _propTypes["default"].exact({
    beforeEnter: _propTypes["default"].string,
    entering: _propTypes["default"].string,
    beforeLeave: _propTypes["default"].string,
    leaving: _propTypes["default"].string
  }),
  disableInitialAnimation: _propTypes["default"].bool,
  delay: _propTypes["default"].number,
  duration: _propTypes["default"].number.isRequired
});

_defineProperty(TinyTransition, "defaultProps", {
  children: null,
  classNames: {
    beforeEnter: "before-enter",
    entering: "entering",
    beforeLeave: "before-leave",
    leaving: "leaving"
  },
  duration: 500,
  delay: 0
});

var _default = TinyTransition;
exports["default"] = _default;